require 'endymion/api'
module Endymion
  
  def self.new(datastore_name, datastore_opts={})
    Endymion::API.new(new_datastore(datastore_name, datastore_opts))
  end

  def self.new_datastore(name, opts={})
    begin
      require "endymion/#{name}"
    rescue LoadError
      raise "Can't find datastore implementation: #{name}"
    end
    ds_klass = Endymion.const_get(Util.class_name(name.to_s))
    ds_klass.new(opts)
  end
  
  def self.new?(record)
    !record.has_key?(:key)
  end
end