require 'endymion/format'

module Endymion
  class FieldSpec

    attr_reader :name, :default, :db_name

    def initialize(name, opts={})
      @name = name
      @default = opts[:default]
      @type = opts[:type]
      @packer = opts[:packer]
      @unpacker = opts[:unpacker]
      @db_name = opts[:db_name] ? Format.format_field(opts[:db_name]) : name
      @api = opts[:api]
    end

    def pack(value)
      if @packer && @packer.respond_to?(:call)
        @packer.call(value)
      elsif @type
        type_packer = @api.packer_for(@type)
        type_packer ? type_packer.call(value) : value
      else
        value
      end
    end

    def unpack(value)
      if @unpacker && @unpacker.respond_to?(:call)
        @unpacker.call(value)
      elsif @type
        type_packer = @api.unpacker_for(@type)
        type_packer ? type_packer.call(value) : value
      else
        value
      end
    end

  end
end